<template>
    <div :class="{'white-block': block}">
        <div class="padding">
            <h3>{{profile ? 'Адрес регистрации' : 'Место нахождения работодателя'}}</h3>
        </div>
        <hr v-if="block"/>
        <div class="padding">
            <div class="row">
                <div class="column" style="position: relative">
                    <label for="region">{{profile ? 'Район, населенный пункт, улица' : 'Регион, город (населенный пункт)'}}</label>
                    <input type="text" id="region" name="region" data-field-id="address.region"
                           v-model="regionSearch"
                           @focus="display = 'region'"
                           @input="getSuggestDebounce"
                           @keyup.up.prevent="prevSuggestion(suggestionsUnique)"
                           @keyup.down.prevent="nextSuggestion(suggestionsUnique)"
                           @keyup.enter.prevent="setSuggestion(suggestionsUnique)"
                           @keyup.esc="getFirstAddress"
                           @keydown.tab="nextSuggestion"
                           autocomplete="off"
                           v-validate="'required|max:250'"
                           :class="[{error: getValidateClass('region') || $errors.includes('address.region')}, {'data-processing': SUGGESTIONS_LOADER.location}]"
                           ref="address"
                           data-code="address.regionInvalidFormat, address.cityInvalidFormat, address.settlementInvalidFormat, address.streetInvalidFormat, addressFiases.valueTooShort,
                           addressFiases.valueInvalidFormat, addressFiases.region_fias_idNotMatchRequiredFormat, addressFiases.area_fias_idNotMatchRequiredFormat,
                           addressFiases.city_fias_idNotMatchRequiredFormat, addressFiases.settlement_fias_idNotMatchRequiredFormat, addressFiases.street_fias_idNotMatchRequiredFormat,
                           workAddress.regionInvalidFormat, workAddress.cityInvalidFormat, workAddress.settlementInvalidFormat, workAddress.streetInvalidFormat, workAddressFiases.valueTooShort,
                           workAddressFiases.valueInvalidFormat, workAddressFiases.region_fias_idNotMatchRequiredFormat, workAddressFiases.area_fias_idNotMatchRequiredFormat,
                           workAddressFiases.city_fias_idNotMatchRequiredFormat, workAddressFiases.settlement_fias_idNotMatchRequiredFormat, workAddressFiases.street_fias_idNotMatchRequiredFormat"
                    >
                    <ul class="options-list" v-show="showRegionSuggestions">
                        <li v-for="(item, index) in suggestionsUnique"
                            @click="setSuggestion(suggestionsUnique, index)"
                            :class="{'highlighted': index === selectedSuggestion}"
                        >{{createRegionStringForSuggestion(item.data)}}</li>
                    </ul>
                    <validate-message v-show="vErrors.has('region')">
                        {{ vErrors.first('region') }}
                    </validate-message>
                    <div class="warning-yellow-block" v-if="profile">
                        <ul class="without-marker">
                            <li><strong>1.</strong> Начните вводить адрес и выберите из списка.</li>
                            <li><strong>2.</strong> В случае, если в вашем населенном пункте (деревне, селе) улица существует, но вы преднамеренно не указали её, по заявке будет отказ!</li>
                        </ul>
                    </div>
                </div>

            </div>
            <div v-if="profile" class="row">
                <!-- дом -->
                <div class="columns two-third">
                    <label for="house">Дом</label>
                    <input type="text" id="house" name="house"
                           v-model="address.house"
                           @input="getHouseSuggest"
                           @keyup.up.prevent="prevSuggestion(suggestionsHouse)"
                           @keyup.down.prevent="nextSuggestion(suggestionsHouse)"
                           @keyup.enter.prevent="setSuggestion(suggestionsHouse)"
                           @keyup.esc="display = false"
                           @focus="display = 'house'"
                           autocomplete="off"
                           v-validate="'required'"
                           :class="[getValidateClass('region'), {'data-processing': SUGGESTIONS_LOADER.house}]"
                           data-code="addressFiases.house_fias_idNotMatchRequiredFormat, workAddressFiases.house_fias_idNotMatchRequiredFormat"
                    >
                    <ul class="options-list" v-show="showHouseSuggestions">
                        <li v-for="(item, index) in suggestionsHouse"
                            @click="setSuggestion(suggestionsHouse, index)"
                            :class="{'highlighted': index === selectedSuggestion}"
                        >{{item.value}}</li>
                    </ul>
                    <validate-message v-show="vErrors.has('house')">
                        {{ vErrors.first('house') }}
                    </validate-message>
                </div>
                <!-- индекс -->
                <div class="columns two-third">
                    <label for="addressIndex">Индекс</label>
                    <input type="text"
                           id="addressIndex"
                           name="addressIndex"
                           v-model="address.postal_code"
                           @input="setPostalCode"
                           v-mask="'######'"
                           v-validate="'required|addressIndex'"
                           autocomplete="off"
                           :class="getValidateClass('addressIndex')"
                           data-code="address.postalCodeInvalidFormat, address.postalCodeNotInAvailableRange, workAddress.postalCodeInvalidFormat, workAddress.postalCodeNotInAvailableRange"
                    >
                    <validate-message v-show="vErrors.has('addressIndex')">
                        {{ vErrors.first('addressIndex') }}
                    </validate-message>
                </div>
                <!-- корпус -->
                <div class="columns two-third">
                    <label for="housing">Корпус</label>
                    <input type="text"
                           id="housing"
                           v-model="address.housing"
                           v-mask="'######'"
                           autocomplete="off"
                    >
                </div>
                <!-- строение -->
                <div class="columns two-third">
                    <label for="building">Строение</label>
                    <input type="text"
                           id="building"
                           v-model="address.building"
                           autocomplete="off"
                    >
                </div>
                <!-- кв или офис -->
                <div class="columns two-third">
                    <label for="flat">{{profile ? 'Квартира' : 'Офис'}}</label>
                    <input type="text"
                           id="flat"
                           name="flat"
                           v-mask="'XXXXX'"
                           v-model="address.flat"
                           autocomplete="off"
                           data-code="workAddress.flatInvalidFormat"
                    >
                </div>
            </div>
            <div class="row" v-if="showNoStreetCheckBox">
                <div class="column checkbox">
                    <input type="checkbox"
                           name="doNotHaveStreet"
                           id="doNotHaveStreet"
                           v-model="address.doNotHaveStreet"
                           data-code="address.doNotHaveStreetNotInAvailableRange, workAddress.doNotHaveStreetNotInAvailableRange"
                    >
                    <label for="doNotHaveStreet" ref="doNotHaveStreet"> <span></span>Я подтверждаю, что по моему адресу регистрации улица отсутствует.</label>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    /* eslint-disable */
    import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
    import debounce from 'lodash/debounce'
    import {suggestAddress} from '@/utils/api'
    import {mapGetters} from 'vuex'
    let request;

    export default {
        mixins: [GetValidateClass],
        props: {
            profile: {
                type: Boolean,
                default: true,
            },
            block: {
                type: Boolean,
                default: false,
            }
        },
        data () {
            return {
                regionSearch: '',
                suggestions: [],
                selectedSuggestion: 0,
                selectedSuggestionData: [],
                namespace: null,// где редактируем данные
                display: false, // показывать подскази или нет. region = для полного адреса, house - для дома, false - скрыть
                address: {
                    postalCode: null,
                    postal_code: null,
                    region: null,
                    city: null,
                    settlement: null,
                    street: null,
                    doNotHaveStreet: false,
                    house: null,
                    geoLat: null,
                    geoLon: null,
                    housing: null,
                    building: null,
                    flat: null
                },
                fiases: {
                    value: null,
                    region_fias_id: null,
                    area_fias_id: null,
                    city_fias_id: null,
                    settlement_fias_id: null,
                    street_fias_id: null,
                    house_fias_id: null
                },
                fiasValue: '',

                flat: '',
                doNotHaveStreet: false,

                init: false
            }
        },
        computed: {
            suggestionsUnique () {
                const data = []
                const result = []
                this.suggestions.forEach((item) => {
                    // не показываем подсказки со станциями метро
                    if (item.data.street_type === 'м') return;
                    const string = this.createRegionStringForSuggestion(item.data)
                    if (!data.includes(string)) {
                        result.push(item)
                        data.push(string)
                    }
                })
                return result
            },
            suggestionsHouse () {
                this.selectedSuggestion = -1;
                return this.suggestions.filter((item) => {
                    return item.data.house && ((this.address.street && (this.address.street === item.data.street)) || (!this.address.street));
                }).map((item) => {
                    let value = '';
                    if (!this.address.area && item.data.area) {
                        value += `${item.data.area_with_type}, `;
                    }
                    if (!this.address.city && item.data.city) {
                        value += `${item.data.city_with_type}, `;
                    }
                    if (!this.address.settlement && item.data.settlement) {
                        value += `${item.data.settlement_with_type}, `;
                    }
                    if(!this.address.street) {
                        value += `${item.data.street_type || ''} ${item.data.street || ''} `
                    }
                    value += `${item.data.house_type || ''}`
                    value += `${item.data.house}`
                    value += item.data.block ? ` ${item.data.block_type}${item.data.block}` : ''
                    return {
                        value,
                        data: item.data
                    }
                })
            },
            showRegionSuggestions () {
                return this.suggestionsUnique.length && this.display === 'region'
            },
            showHouseSuggestions () {
                return this.suggestionsHouse.length && this.display === 'house'
            },
            showNoStreetCheckBox () {
                return !this.address.street && this.profile
            },
            getAddressFromSuggest () {
                if (!this.selectedSuggestion < 0) {
                    this.selectedSuggestion = 0;
                }
                if (this.showRegionSuggestions) {
                    return this.suggestionsUnique[this.selectedSuggestion];
                } else if (this.showHouseSuggestions) {
                    return this.suggestionsHouse[this.selectedSuggestion];
                }
                return this.suggestions[this.selectedSuggestion]
            },
            ...mapGetters(['SUGGESTIONS_LOADER'])
        },
        watch: {
            flat (flat) {
                this.address.flat = flat;
                this.saveState()
            },
            doNotHaveStreet (state) {
                this.address.doNotHaveStreet = state;
                this.saveState()
            },
            address: {
                deep: true,
                handler () {
                    this.saveState()
                }
            },
            'address.postal_code' (v) {
                this.profile ? this.$user.address.postalCode = v : this.$user.workAddress.postalCode = v;
            }
        },
        created () {
            this.address = this.profile ? this.$user.address : this.$user.workAddress;
            this.fiases = this.profile ? this.$user.addressFiases : this.$user.workAddressFiases;

            if (this.$auth.isAuth) {
                this.address.postal_code = this.profile ? this.$user.address.postalCode : this.$user.workAddress.postalCode;
                this.address.region = this.profile ? this.$user.address.region : this.$user.workAddress.region;
            }

            this.createRegionSearchString();
            this.getSuggestDebounce  = debounce(this.getSuggest, 500);

        },
        updated () {
            this.address.postalCode = this.address.postal_code;
            if (this.profile) {
                this.$store.commit('SET_USER_POSTAL_CODE', this.address.postalCode);
            } else {
                this.$store.commit('SET_USER_WORK_POSTAL_CODE', this.address.postalCode);
            }``
        },
        methods: {
            async listSuggestAddress (address, {loader}) {
                this.$store.commit('SUGGESTIONS_SET_LOADER', {[loader]: true}); // включаем лоадер, пока грузяться данные

                if(request) {
                    request.abort(); // отменяем предыдующие запросы, если запросы не успели подгрузиться
                }

                request = await this.$store.dispatch('SUGGESTIONS_GET_ADDRESS', address);

                request.onreadystatechange = function () {
                    // результат на то, что email введен верно
                    // console.log('result', JSON.parse(request.response))
                    if(request.readyState === XMLHttpRequest.DONE && request.status === 200) {
                        // this.$store.commit('SUGGESTIONS_SET_EMAIL_LIST', JSON.parse(request.response));
                        loader === 'location' ? this.display = 'region' : this.display = 'house';
                        this.suggestions = JSON.parse(request.response).suggestions;
                        this.$store.commit('SUGGESTIONS_SET_LOADER', {[loader]: false});
                        request = null;
                    }
                }.bind(this);
            },
            setPostalCode({target}) {
                this.address.postal_code = target.value;
                /*if (this.profile) {
                  this.$store.commit('SET_USER_POSTAL_CODE', target.value);
                } else {
                  this.$store.commit('SET_USER_WORK_POSTAL_CODE', target.value);
                }*/
            },

            getFirstAddress () {
                if (this.suggestions.length) {
                    this.setSuggestion(this.selectedSuggestion || 0)
                }
                this.display = false
            },
            saveState () {
                // иногда бывает пустое значение или ноль, но этого быть не должно.
                // поэтому обнуляем
                for(const key in this.fiases) {
                    if(!this.fiases[key] || this.fiases[key] === "0") {
                        this.fiases[key] = null
                    }
                }

                if (this.profile) {
                    this.$user.address = this.address;
                    this.$user.addressFiases = this.fiases;
                    this.$user.address.region = this.address.region_kladr_id || this.address.region;
                    this.$user.address.postalCode = this.address.postal_code;
                } else {
                    this.address.doNotHaveStreet = this.address.street ? false : true;
                    this.$user.workAddress= this.address;
                    this.$user.workAddressFiases = this.fiases;
                    this.$user.workAddress.region = this.address.region_kladr_id || this.address.region;
                    this.$user.workAddress.postalCode = this.address.postal_code;
                }
            },
            getHouseSuggest () {
                this.$validator.errors.clear('house')
                // ищем дом, только если есть улица или спутник (деревня, хутор и тп, где может не быть улицы)
                if (this.fiases.street_fias_id || this.address.settlement || this.address.region) {
                    this.listSuggestAddress(`${this.regionSearch}, д ${this.address.house}`, {loader: 'house'})
                    // this.$store.commit('SUGGESTIONS_SET_LOADER', {house: true});
                    // suggestAddress(`${this.regionSearch}, д ${this.address.house}`)
                    //   .then((response) => {
                    //     this.suggestions = response.data.suggestions
                    //     this.display = 'house'
                    //   })
                    //   .finally(() => this.$store.commit('SUGGESTIONS_SET_LOADER', {house: false}))
                }
            },
            getSuggest () {
                this.listSuggestAddress(this.regionSearch, {loader: 'location'})
                // this.$store.commit('SUGGESTIONS_SET_LOADER', {location: true});
                // suggestAddress(this.regionSearch)
                //   .then((response) => {
                //     // console.log(response)
                //     this.suggestions = response.data.suggestions
                //     this.display = 'region'
                //   })
                //   .catch((e) => {
                //     console.warn(e)
                //   })
                //   .finally(() => this.$store.commit('SUGGESTIONS_SET_LOADER', {location: false}))
            },
            nextSuggestion (s) {
                if (!this.display) return;
                let index = this.selectedSuggestion + 1
                if (index >= this.suggestions.length) {
                    this.selectedSuggestion = 0;
                    this.selectedSuggestionData = s;
                } else {
                    this.selectedSuggestion = index;
                    this.selectedSuggestionData = s;
                }
            },
            prevSuggestion (s) {
                if (!this.display) return;
                let index = this.selectedSuggestion - 1;
                if (index < 0) {
                    this.selectedSuggestion = s.length - 1;
                    this.selectedSuggestionData = s;
                } else {
                    this.selectedSuggestion = index;
                    this.selectedSuggestionData = s;
                }

            },
            setSuggestion (suggestions, index) {
                if (index !== undefined && typeof index === "number") {
                    this.selectedSuggestion = index;
                }

                this.selectedSuggestionData = suggestions;
                this.buildAddressObject();
                this.$nextTick(() => {
                    // this.display = false;
                })

            },
            buildAddressObject () {

                this.display = false;
                this.suggestions = [];
                if (this.selectedSuggestion === -1) {
                    return;
                }

                let address = this.selectedSuggestionData[this.selectedSuggestion]
                if (address) {
                    address = address.data;
                }
                this.createRegionSearchString(address)
            },
            createRegionStringForSuggestion (address) {
                if(this.profile) {
                    return (address.region_with_type && address.region_with_type !== 'г Санкт-Петербург' && address.region_with_type !== 'г Москва' ? address.region_with_type + ', ' : '') + // Название области
                        (address.city_type ? address.city_type + '. ' : '') + // тип (город, деревня, село)
                        (address.city ? address.city : '') + // название города
                        (address.area_with_type ? ' ' + address.area_with_type : '') + // район, если такой есть
                        (address.settlement_with_type ? ', ' + address.settlement_with_type : '') + // район, если такой есть
                        (address.street_type ? ', ' + address.street_type + '. ' : '') + // тип (улица, б-р, п-к)
                        (address.street ? address.street : '')
                } else {
                    return (address.region_with_type && address.region_with_type !== 'г Санкт-Петербург' && address.region_with_type !== 'г Москва' ? address.region_with_type + ', ' : '') + // Название области
                        (address.city_type ? address.city_type + '. ' : '') + // тип (город, деревня, село)
                        (address.city ? address.city : '') + // название города
                        (address.area_with_type ? ' ' + address.area_with_type : '') + // район, если такой есть
                        (address.settlement_with_type ? ', ' + address.settlement_with_type : '') // район, если такой есть
                }
            },
            createRegionSearchString (address) {

                if (address) {
                    if(this.profile) {
                        this.regionSearch =
                            (address.region_with_type && address.region_with_type !== 'г Санкт-Петербург' && address.region_with_type !== 'г Москва' ? address.region_with_type + ', ' : '') + // Название области
                            (address.city_type ? address.city_type + '. ' : '') + // тип (город, деревня, село)
                            (address.city ? address.city : '') + // название города
                            (address.area_with_type ? ' ' + address.area_with_type : '') + // район, если такой есть
                            (address.settlement_with_type ? ', ' + address.settlement_with_type : '') + // район, если такой есть
                            (address.street_type ? ', ' + address.street_type + '. ' : '') + // тип (улица, б-р, п-к)
                            (address.street ? address.street : '')
                    } else {
                        this.regionSearch =
                            (address.region_with_type && address.region_with_type !== 'г Санкт-Петербург' && address.region_with_type !== 'г Москва' ? address.region_with_type + ', ' : '') + // Название области
                            (address.city_type ? address.city_type + '. ' : '') + // тип (город, деревня, село)
                            (address.city ? address.city : '') + // название города
                            (address.area_with_type ? ' ' + address.area_with_type : '') + // район, если такой есть
                            (address.settlement_with_type ? ', ' + address.settlement_with_type : '') // район, если такой есть
                    }
                } else {
                    this.regionSearch = this.profile ? this.$user.addressFiases.value : this.$user.workAddressFiases.value;
                }
                this.buildAddressMetaData(address)
            },
            buildAddressMetaData (address) {
                let fiases
                if (address) {
                    this.address.region = address.region_kladr_id
                    this.fiases.value = this.regionSearch
                    this.fiases.region_fias_id = address.region_fias_id
                    this.fiases.area_fias_id = address.area_fias_id
                    this.fiases.city_fias_id = address.city_fias_id
                    this.fiases.settlement_fias_id = address.settlement_fias_id
                    this.fiases.street_fias_id = address.street_fias_id
                    this.fiases.house_fias_id = address.house_fias_id
                    this.address = Object.assign(this.address, address);
                    this.computeBlocksAndBuilding(address)
                } else {
                    this.address = this.profile ? {...this.$user.address} : {...this.$user.workAddress};
                    this.fiases = this.profile ? {...this.$user.addressFiases} : {...this.$user.workAddressFiases};
                }

                if (!this.address.city) {
                    this.address.city = this.address.settlement
                }
            },
            computeBlocksAndBuilding (address) {
                if (address) {
                    if (address.block_type === 'к') {
                        if (address.block.indexOf('стр') > -1) {
                            const [housing, building] = address.block.split('стр')
                            console.log('set housing and building', housing, building)
                            this.address.housing = housing.trim(); // корпус
                            this.address.building = building.trim(); // строение
                        } else {
                            this.address.housing = this.address.block
                        }
                    } else if (['стр', 'сооружение'].includes(address.block_type)) {
                        this.address.building = address.building || address.block;
                        this.address.block = ''
                    }
                }
            },
        }
    }
</script>

<style scoped lang="scss">
    .options-list {
        display: flex;
        flex-direction: column;
        margin-top: -40px;
        border: 1px solid #dbdbdb;
        border-radius: 0 0 3px 3px;
        position: absolute;
        width: auto;
        max-width: 400px;
        overflow: hidden;
        list-style: none;
        z-index: 6;
        &  li {
            width: 100%;
            flex-wrap: wrap;
            background: white;
            margin: 0;
            border-bottom: 1px solid #eee;
            color: #363636;
            padding: 7px 20px;
            cursor: pointer;
            &.highlighted {
                background: #f8f8f8;
            }
        }
    }
    .without-marker li {
        border-bottom: none;
        background: none;
    }
</style>
